*  Program...........: CHK4DUPE.PRG
*  Author............: Steven Kern 
*  Project...........: 
*  Created...........: 10/18/93
*  Copyright.........: (c) Steven Kern, 1993
*) Description.......: Generic routine to check for duplicate record entry
*  Calling Samples...: IF !LASTKEY() = 27 AND !Chk4Dupe()
*                        _CUROBJ = _CUROBJ
*                      ENDIF !LASTKEY() = 27 AND !Chk4Dupe()
*  Parameter List....: 
*  Major change list.: 

lcVar = VARREAD()					&& field name

IF RECCOUNT() = 0 	&& it's the first record entered in the table
  RETURN			&& no point in any further processing
ENDIF RECCOUNT() = 0  

IF EMPTY(EVALUATE("m."+lcVar))		&& don't bother with empty fields
   m.x = nAlert( 'caution', 'OK', "You have left a key field blank. " + ;
                 "Please check the entry again.")
   llreturn = .F.
   RETURN llreturn
ENDIF EMPTY(EVALUATE("m."+lcVar))

*-- Set up variables
lcCheckIt = EVALUATE("m."+lcVar)	&& What's stored in the field
llreturn  = .T.						&& value to return
lnRecNo   = IIF(EOF(),0,RECNO())	&& store record number
lcOldOrder= ORDER()					&& old order

SET ORDER TO (lcVar) 

*-- Set EXACT ON 
lcOldExact = SET('EXACT')
SET EXACT ON

*-- Check for duplicate entry; if RECNO() = lnRecNo
*   we've got a duplicate
*   this works for both Add and Edit modes

IF SEEK(ALLTRIM(UPPER(lcCheckIt))) AND ;
   (m.lhLastBtn = 'Add' OR RECNO() # lnRecNo)
   m.x = nAlert( 'Stop', 'OK', CHR(34) + ALLTRIM(lcCheckIt) + CHR(34) ;
               + CHR(13) + " already exists in the data table." + ;
               " Duplicate entries are not allowed in this field!")
  llreturn = .F.  
ENDIF SEEK(lcCheckIt) AND RECNO() # lnRecNo

*-- put order back to original order
*   and return record pointer to original position

SET ORDER TO (lcOldOrder)
IF lnRecNo = 0				&& we're at the EOF
  GO BOTTOM
  SKIP
ELSE
  GO lnRecNo
ENDIF lnRecNo = 0

*-- Set exact back the way it was
SET EXACT &lcOldExact  
RETURN llreturn

