*  Program...........: CHKALIAS.PRG
*  Author............: Steven Kern 
*  Project...........: DDICT26
*  Created...........: 05/19/94
*  Copyright.........: (c) Steven Kern, 1994
*) Description.......: Generic routine to check for duplicate record entry
*  Calling Samples...: IF !LASTKEY() = 27 AND !Chk4Dupe()
*                        _CUROBJ = _CUROBJ
*                      ENDIF !LASTKEY() = 27 AND !Chk4Dupe()
*  Parameter List....: 
*  Major change list.: 

PRIVATE ALL LIKE j*

jcVar = VARREAD()					&& field name

IF RECCOUNT() = 0 	&& it's the first record entered in the table
  RETURN			&& no point in any further processing
ENDIF RECCOUNT() = 0  


*-- Set up variables
jcCheckIt = EVALUATE(jcVar)	        && What's stored in the field
jlreturn  = .T.						&& value to return
jnRecNo   = IIF(EOF(),0,RECNO())	&& store record number
jcOldOrder= ORDER()					&& old order

SET ORDER TO (jcVar) 

*-- Set EXACT ON 
jcOldExact = SET('EXACT')
SET EXACT ON

*-- Check for duplicate entry; if RECNO() = jnRecNo
*   we've got a duplicate

IF SEEK(ALLTRIM(UPPER(jcCheckIt))) AND (RECNO() # jnRecNo)
  DO Alert.spr WITH " Duplicate entries are not allowed in this field!"
  jlreturn = .F.  
ENDIF SEEK(jcCheckIt) AND RECNO() # jnRecNo

*-- put order back to original order
*   and return record pointer to original position

SET ORDER TO (jcOldOrder)
IF jnRecNo = 0				&& we're at the EOF
  GO BOTTOM
  SKIP
ELSE
  GO jnRecNo
ENDIF jnRecNo = 0

*-- Set exact back the way it was
SET EXACT &jcOldExact  
RETURN jlreturn

